(* MAIL SMS 1.0 ; programma scritto interamente da Davide "edivada@iol.it*)
(* e rilasciata con LICENZA GPL *)
(* Potete modificare e re-distribuire questo programma *)
(* lasciando intatti questi commenti *)
(* Per qualiasi info potete rivolgermi alla mia caselle email; Davide  *)


unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Mask, StdCtrls, ExtCtrls, Menus, ComCtrls, IdBaseComponent,
  IdComponent, IdTCPConnection, IdTCPClient, IdMessageClient, IdPOP3,
  CoolTrayIcon, IdSMTP, ImgList;

type
  TForm1 = class(TForm)
    Button1: TButton;
    host: TEdit;
    pass: TMaskEdit;
    porta: TEdit;
    contatore: TTimer;
    Label1: TLabel;
    Label2: TLabel;
    user: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    cell: TEdit;
    tempo: TEdit;
    Label6: TLabel;
    Label7: TLabel;
    MainMenu1: TMainMenu;
    About1: TMenuItem;
    prefisso: TComboBox;
    Label8: TLabel;
    Label9: TLabel;
    IdPOP31: TIdPOP3;
    CoolTrayIcon1: TCoolTrayIcon;
    PopupMenu1: TPopupMenu;
    About2: TMenuItem;
    Exit1: TMenuItem;
    Exit2: TMenuItem;
    IdSMTP1: TIdSMTP;
    smpt: TEdit;
    Label10: TLabel;
    Psmtp: TEdit;
    Button2: TButton;
    ImageList1: TImageList;
    About3: TMenuItem;
    N1: TMenuItem;
    Exit3: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure cellKeyPress(Sender: TObject; var Key: Char);
    procedure tempoKeyPress(Sender: TObject; var Key: Char);
    procedure Button1Click(Sender: TObject);
    procedure contatoreTimer(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure About2Click(Sender: TObject);
    procedure Exit2Click(Sender: TObject);
    procedure CoolTrayIcon1DblClick(Sender: TObject);
    procedure About3Click(Sender: TObject);
    procedure Exit3Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  nmail: integer;
implementation

uses about;

{$R *.dfm}
Function Get_Connection_State:Boolean;StdCall;External'Connection.dll';

procedure TForm1.FormCreate(Sender: TObject);
begin                        (* in fase di creazione della mainform *)
  cooltrayicon1.CycleInterval := 400; (* abilita le opzioni per l'icona *)
  cooltrayicon1.CycleIcons := true;
  prefisso.ItemIndex := 0;     (* nella taskbar e disabilita il timer*)
  contatore.Enabled := false;
end;

procedure TForm1.cellKeyPress(Sender: TObject; var Key: Char);
begin
   if (( key < '0' ) or ( key > '9' )) and ( key <> #8 )then
    key := #13;  (* per il campo Cell, accetta solo cifre numeriche *)
end;

procedure TForm1.tempoKeyPress(Sender: TObject; var Key: Char);
begin
  if ( key < '0' ) or ( key > '9' ) then
    key := #13; (* accetta solo cifre numeriche per il campo del Tempo *)
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  If (host.text = '') or (user.text = '')or (pass.text = '') or (smpt.text = '') or ( cell.text ='' ) or ( tempo.Text = '') then
    messagedlg('Completa tutti i campi correttamente',mtinformation,[mbok],0)
  else   (* se tutti i campi non sono completi, visualizza Errore *)
  If not(Get_Connection_State) then
     messagedlg('Hey, verifica prima di essere connesso alla rete',mtinformation,[mbok],0)
  else (* Se non  attiva una connessione, visualizza errore *)
    Begin  (* altrimenti significa che tutto  OK *)
      nmail := 0;
      cooltrayicon1.iconvisible := true;
      cooltrayicon1.HideMainForm;
      contatore.interval := strtoint(tempo.text ) * 60000;
      idpop31.Username := user.text;
      idpop31.password :=pass.text;
      idpop31.Port := 110; (* nascondi la form e visualizza l'icona in taskbar *)
      idpop31.Host := host.Text;
      idsmtp1.Host := smpt.Text;
      idsmtp1.Port := 25;
      contatore.Enabled := true; (* attiva il Timer *)
      try  (* effettua una connessione al Pop3 di prova *)
        idpop31.connect;
      except
      on e:exception do
        begin  (*se c' un errore nel POP3 *)
          cooltrayicon1.ShowMainForm; (* visualizza la Mainform *)
          messagedlg('Attenzione,errore nella connessione',mterror,[mbok],0);
          messagedlg(e.Message,mtinformation,[mbok],0);
          contatore.Enabled := false; (* mostra il messaggio di errore *)
        end;
      end;     (* disabilita il contatore *)
      idpop31.disconnect;
    end; (* in caso contrario disconnettiti dal POP, visto che la connessione *)
end; (*  andata a buon fine *)

procedure TForm1.contatoreTimer(Sender: TObject);
begin
  try
    idpop31.connect;
  except
  on e:exception do
    begin  (* verifica che il programma non si sia disconnesso *)
      cooltrayicon1.ShowMainForm;
      messagedlg('Attenzione,errore nella connessione',mterror,[mbok],0);
      contatore.Enabled := false;
      exit; (* esci dalla procedura *)
    end;
  end;
  If  ( Idpop31.checkmessages > Nmail ) then
    Begin (* dopo essersi connesso al Pop, bisogna leggere il numero di msg *)
      try (* presenti; se sono maggiori di Nmail occorre inoltrare l'sms di notifica *)
        idsmtp1.connect;
      except
      on e:exception do
        begin
          cooltrayicon1.ShowMainForm;
          messagedlg('Attenzione,errore nella connessione con il server Smtp',mterror,[mbok],0);
          contatore.Enabled := false;
          idpop31.Disconnect;
          exit;
        end;
      end;
      try (* qui si invia al numero telefonico il messaggio di notifica *)
        idsmtp1.QuickSend(smpt.text,'','+39'+prefisso.Text+cell.text+'@sms.vodafone.it','3167@omnitel.it','Hai '+inttostr(idpop31.CheckMessages - nmail)+' messaggi nuovi in email');
      except
      on f:exception do
        begin
          cooltrayicon1.ShowMainForm;
          messagedlg('Attenzione,errore nella trasmissione dell''email: controllare di essere autorizzati',mterror,[mbok],0);
          contatore.Enabled := false;
          idpop31.Disconnect;
          idsmtp1.Disconnect;
          exit;
        end;
      end;  (* setta Nmail al numero di messaggi presenti *)
      Nmail:= idpop31.CheckMessages;
      idsmtp1.Disconnect;
      idpop31.disconnect;
    end
  else
    idpop31.disconnect;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  aboutbox.Show;
end;

procedure TForm1.About2Click(Sender: TObject);
begin
  aboutbox.show
end;

procedure TForm1.Exit2Click(Sender: TObject);
begin
  If MessageDlg('Sei sicuro di voler uscire',mtConfirmation, [mbYes, mbNo],0) = mrYes then
    close;
end;


procedure TForm1.CoolTrayIcon1DblClick(Sender: TObject);
begin   (* se si clicca sull'icona nella taskbar vengono eseguiti queste *)
  contatore.Enabled := false;   (* istruzioni *)
  cooltrayicon1.ShowMainForm;
  cooltrayicon1.iconvisible := false;
end;

procedure TForm1.About3Click(Sender: TObject);
begin
  Form1.About2Click(sender);
end;

procedure TForm1.Exit3Click(Sender: TObject);
begin
  Form1.exit2click(sender);
end;

end.
